
#ONOMA:LEANDROS TZANAKIS-ARNAOUTAKIS
#AEM:985
#PROVLIMA GPS


## module gaussElimin
 #x = gaussElimin(a,b).
    #Solves [a]{b} = {x} by Gauss elimination 

from numpy import dot
from numpy import array

a = array([[ 1.11, 2.87,0.00,1.54], \
           [2.55, 0.00,1.08,1.01 ], \
           [2.14,1.43,2.29,1.23]])           #SYNTETAGMENES THESHS
           

b = array([[1.29, 1.31,2.75, 4.06]])          #ANTISTOIXOS XRONOS

def gaussElimin(a,b):
    n = len(b)
  # Elimination Phase
    for k in range(0,n-1):
        for i in range(k+1,n):
           if a[i,k] != 0.0:
               lam = a [i,k]/a[k,k]
               a[i,k+1:n] = a[i,k+1:n] - lam*a[k,k+1:n]
               b[i] = b[i] - lam*b[k]
               
  # Back substitution
    for k in range(n-1,-1,-1):
        b[k] = (b[k] - dot(a[k,k+1:n],b[k+1:n]))/a[k,k]
    return b

x = gaussElimin(a,b)                  #LUSH SYNTETAGMENWN ODOIPOROU

print x
  



